<?php

/**
* Joomla Community Builder User Plugin: plug_cbagora
* @version $Id$
* @package plug_agora
* @subpackage cb.agora.php
* @author Denis Podgorodnichenko
* @copyright (C) Denis Podgorodnichenko and Hazzaak, www.joomlame.com
* @license Limited  http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

/*
TODO:
CB Language files
Fix google maps issues
*/

if ( !( defined( '_VALID_CB' ) || defined( '_JEXEC' ) || defined( '_VALID_MOS' ) ) ) {
    die( 'Direct Access to this location is not allowed.' );
}

require_once('agora.functions.php');

class getAgoraPreviewTab extends cbTabHandler {
/**
     * Construnctor
     */
    function getAgoraPreviewTab()
    {
        $this->cbTabHandler();
    }

    /**
    * Generates the HTML to display the user profile preview tab
    * @param object tab reflecting the tab database entry
    * @param object mosUser reflecting the user being displayed
    * @param int 1 for front-end, 2 for back-end
    * @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
    */
    function getDisplayTab($tab,$user,$ui)
    {
        global $_CB_framework;
        $return = null;

        $lang = JFactory::getLanguage();
        $lang->load('plg_cbagora');

        //$params = $this->params; // get parameters (plugin and related tab)

        $agoraUser = cbAgoraGetUser($user->id);

        $dateFormat = cbAgoraDateFormat();
        $timeFormat = cbAgoraTimeFormat();
        $gmaps = cbAgoraGMaps();
        $lng = empty($agoraUser['longitude']) ? $gmaps['def_lng'] : $agoraUser['longitude'];
        $lat = empty($agoraUser['latitude']) ? $gmaps['def_lat'] : $agoraUser['latitude'];

        switch($agoraUser['gender']) {
            case 1:
                $gender = JText::_('CB_AGORA_GENDER_MALE');
                break;
            case 2:
                $gender = JText::_('CB_AGORA_GENDER_FEMALE');
                break;
            default:
                $gender = JText::_('CB_AGORA_GENDER_HIDDEN');
        }

        //section personal
        $return .= "<p>" . JText::_('CB_AGORA_USERNAME') . " :\t" . $agoraUser['username'] . "</p>\n";
        $return .= "<p>" . JText::_('CB_AGORA_TITLE') . ":\t" . $agoraUser['title'] . "</p>\n";
        $return .= "<p>" . JText::_('CB_AGORA_LOCATION') .":\t" . $agoraUser['location'] . "</p>\n";

        $return .= "<script type=\"text/javascript\" src=\"http://maps.google.com/maps?file=api&amp;v=1&amp;key=".$gmaps['key']."\"></script>\n";
        $return .= "<script type=\"text/javascript\" src=\""
          . $_CB_framework->getCfg('live_site') . "/components/com_comprofiler/plugin/user/plug_agora/agora.js\"></script>\n";
        $return .= "<div id=\"map\" style=\"width: 500px; height: 400px; ;\"></div>\n";
        $return .= "<script type=\"text/javascript\">\n
                    //<![CDATA[
                    window.onload=";
        $return .= "gMapProfilePreview($lng, $lat, " . $gmaps['def_zoom'].");\n
                    //]]>
                    </script>\n";

        $return .= "<p>" . JText::_('CB_AGORA_WEBSITE') . ":\t<a href=\"" . $agoraUser['url'] .  "\">" . $agoraUser['url'] . "</a></p>";
        $return .= "<p>" . JText::_('CB_AGORA_EMAIL') . ":\t<a href=\"mailto:" . $agoraUser['email'] .  "\">" . $agoraUser['email'] . "</a></p>";
        $return .= "<p>" . JText::_('CB_AGORA_GENDER') .":\t" . $gender ."</p>";

        $dateFormatTmp = $dateFormat;
        if ($agoraUser['hide_age']==1)
            $dateFormat = trim(eregi_replace('[ \./-]?y+[ \./-]?', '', $dateFormat));

        $return .= "<p>" . JText::_('CB_AGORA_BIRTHDAY') . ":\t". date($dateFormat, $agoraUser['birthday']) ."</p>";
        $return .= "<p>" . JText::_('CB_AGORA_INTERESTS') . ":\t" . $agoraUser['interests'] . "</p>";
        $return .= "<p>" . JText::_('CB_AGORA_ABOUTME') . ":\t" . $agoraUser['aboutme'] . "</p>";

        //section messaging
        $return .= cbAgoraMessagingSection($agoraUser);

        //section personality
        $return .= "<p>" . JText::_('CB_AGORA_SIGNATURE') . ":\t" . nl2br($agoraUser['signature']) . "</p>\n";

        //user activity
        $return .= "<p>" . JText::_('CB_AGORA_POSTS') . ":\t" . $agoraUser['num_posts'] . "</p>";
        $return .= "<p>" . JText::_('CB_AGORA_LASTPOST') . ":\t" . date($dateFormatTmp. " " . $timeFormat, $agoraUser['last_post']) . "</p>";
        $return .= "<p>" . JText::_('CB_AGORA_REGISTERED') . ":\t" . date($dateFormatTmp. " " . $timeFormat, $agoraUser['registered']) . "</p>";

        return $return;
    } // end or getDisplayTab function
};

class getAgoraMessagingTab extends cbTabHandler{
/**
     * Construnctor
     */
    function getAgoraMessagingTab()
    {
        $this->cbTabHandler();
    }

    /**
    * Generates the HTML to display the user profile messaging tab
    * @param object tab reflecting the tab database entry
    * @param object mosUser reflecting the user being displayed
    * @param int 1 for front-end, 2 for back-end
    * @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
    */
    function getDisplayTab($tab,$user,$ui)
    {
        $lang = JFactory::getLanguage();
        $lang->load('plg_cbagora');

        $return = null;
        $agoraUser = cbAgoraGetUser($user->id);
        $return .= cbAgoraMessagingSection($agoraUser);
        return $return;
    }

/**
    * Generates the HTML to display the user edit tab
    * @param object tab reflecting the tab database entry
    * @param object mosUser reflecting the user being displayed
    * @param int 1 for front-end, 2 for back-end
    * @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
    */
    function getEditTab($tab, $user, $ui)
    {
        $return = null;
        $lang = JFactory::getLanguage();
        $lang->load('plg_cbagora');
        $agoraUser = cbAgoraGetUser($user->id);

        $return .= "<p><input type=\"text\" name=\"jabber\" value=\""
            . $agoraUser['jabber'] . "\" size=\"40\" maxlength=\"75\" />Jabber</p>\n";
        $return .= "<p><input type=\"text\" name=\"icq\" value=\""
            . $agoraUser['icq'] . "\" size=\"12\" maxlength=\"12\" />ICQ</p>\n";
        $return .= "<p><input type=\"text\" name=\"msn\" value=\""
            . $agoraUser['msn'] . "\" size=\"40\" maxlength=\"50\" />MSN</p>\n";
        $return .= "<p><input type=\"text\" name=\"aim\" value=\""
            . $agoraUser['aim'] . "\" size=\"20\" maxlength=\"30\" />AOL IM</p>\n";
        $return .= "<p><input type=\"text\" name=\"yahoo\" value=\""
            . $agoraUser['yahoo'] . "\" size=\"20\" maxlength=\"30\" />Yahoo</p>\n";
        $return .= "<p><input type=\"text\" name=\"xfire\" value=\""
            . $agoraUser['xfire'] . "\" size=\"20\" maxlength=\"30\" />XFire</p>\n";
        $return .= "<p><input type=\"text\" name=\"skype\" value=\""
            . $agoraUser['skype'] . "\" size=\"20\" maxlength=\"30\" />Skype</p>\n";
        return $return;
    }

    /**
    * Saves the user edit tab postdata into the tab's permanent storage
    * @param object tab reflecting the tab database entry
    * @param object mosUser reflecting the user being displayed
    * @param int 1 for front-end, 2 for back-end
    * @param array _POST data for saving edited tab content as generated with getEditTab
    * @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
    */
    function saveEditTab($tab, $user, $ui, $postdata)
    {
        global $_CB_database;

        $jabber = cbAgoraFilter(JString::substr($postdata['jabber'],0,75));
        $icq = cbAgoraFilter(JString::substr($postdata['icq'],0,12));
        $msn = cbAgoraFilter(JString::substr($postdata['msn'],0,50));
        $aim = cbAgoraFilter(JString::substr($postdata['aim'],0,30));
        $yahoo = cbAgoraFilter(JString::substr($postdata['yahoo'],0,30));
        $xfire = cbAgoraFilter(JString::substr($postdata['xfire'],0,30));
        $skype = cbAgoraFilter(JString::substr($postdata['skype'],0,30));

        $return = null;

        $query = "UPDATE #__agora_users SET ";

        $query .= "`jabber`=$jabber, ";
        $query .= "`icq`=$icq, ";
        $query .= "`msn`=$msn, ";
        $query .= "`aim`=$aim, ";
        $query .= "`yahoo`=$yahoo, ";
        $query .= "`xfire`=$xfire, ";
        $query .= "`skype`=$skype ";
        $query .= "WHERE `jos_id`='" . $user->id . "'";

        $_CB_database->setQuery( $query );
        if(!$_CB_database->query())
            JError::raiseWarning(0,$_CB_database->getErrorMsg());
        /*
        $this->_setErrorMSG($_CB_database->getErrorMsg());
        return false;   //FIXME: something strange, it doesn't wish to work
                        //therefore we use JError::raiseWarning function*/

        return true;
    }

}

class getAgoraDisplayTab extends cbTabHandler {
/**
     * Construnctor
     */
    function getAgoraDisplayTab()
    {
        $this->cbTabHandler();
    }

    /**
    * Generates the HTML to display the user profile personality tab
    * @param object tab reflecting the tab database entry
    * @param object mosUser reflecting the user being displayed
    * @param int 1 for front-end, 2 for back-end
    * @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
    */
    function getDisplayTab($tab,$user,$ui)
    {
        $return = null;
        $lang = JFactory::getLanguage();
        $lang->load('plg_cbagora');
        $agoraUser = cbAgoraGetUser($user->id);

        $return .= "<p>" . JText::_('CB_AGORA_SHOW_SMILES') . ":\t" . ($agoraUser['show_smilies']==1?"Yes":"No") . "</p>\n";
        $return .= "<p>" . JText::_('CB_AGORA_SHOW_SIGS') . ":\t" . ($agoraUser['show_sig']==1?"Yes":"No") . "</p>\n";
        $return .= "<p>" . JText::_('CB_AGORA_SHOW_AVATARS') . ":\t" . ($agoraUser['show_avatars']==1?"Yes":"No") . "</p>\n";
        $return .= "<p>" . JText::_('CB_AGORA_SHOW_IMAGES') . ":\t" . ($agoraUser['show_img']==1?"Yes":"No") . "</p>\n";
        $return .= "<p>" . JText::_('CB_AGORA_SHOW_IMAGES_SIGS') . ":\t" . ($agoraUser['show_img_sig']==1?"Yes":"No") . "</p>\n";
        $return .= "<p>" . JText::_('CB_AGORA_REVERSE') . ":\t" . ($agoraUser['reverse_posts']==1?"Yes":"No") . "</p>\n";
        $return .= "<p>" . JText::_('CB_AGORA_TOPICS_PER_PAGE') . ":\t" . $agoraUser['disp_topics'] . "</p>\n";
        $return .= "<p>" . JText::_('CB_AGORA_POSTS_PER_PAGE') . ":\t" . $agoraUser['disp_posts'] . "</p>\n";
        $return .= "<p>" . JText::_('CB_AGORA_MANAGE_REPUTATION') . ":\t" . ($agoraUser['reputation_enable']==1?"Yes":"No") . "</p>\n";

        return $return;
    }
/**
    * Generates the HTML to display the user edit tab
    * @param object tab reflecting the tab database entry
    * @param object mosUser reflecting the user being displayed
    * @param int 1 for front-end, 2 for back-end
    * @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
    */
    function getEditTab($tab, $user, $ui)
    {
        $return = null;
        $lang = JFactory::getLanguage();
        $lang->load('plg_cbagora');
        $agoraUser = cbAgoraGetUser($user->id);

        $return .= "<p><input type=\"checkbox\" name=\"show_smilies\" "
            . ($agoraUser['show_smilies']==1?"checked":"") . " />" . JText::_('CB_AGORA_SHOW_SMILES') . "</p>\n";

        $return .= "<p><input type=\"checkbox\" name=\"show_sig\" "
            . ($agoraUser['show_sig']==1?"checked":"") . " />" . JText::_('CB_AGORA_SHOW_SIGS') . "</p>\n";

        $return .= "<p><input type=\"checkbox\" name=\"show_avatars\" "
            . ($agoraUser['show_avatars']==1?"checked":"") . " />" . JText::_('CB_AGORA_SHOW_AVATARS') . "</p>\n";

        $return .= "<p><input type=\"checkbox\" name=\"show_img\" "
            . ($agoraUser['show_img']==1?"checked":"") . " />" . JText::_('CB_AGORA_SHOW_IMAGES') . "</p>\n";

        $return .= "<p><input type=\"checkbox\" name=\"show_img_sig\" "
            . ($agoraUser['show_img_sig']==1?"checked":"") . " />" . JText::_('CB_AGORA_SHOW_IMAGES_SIGS') . "</p>\n";

        $return .= "<p><input type=\"checkbox\" name=\"reverse_posts\" "
            . ($agoraUser['reverse_posts']==1?"checked":"") . " />" . JText::_('CB_AGORA_REVERSE') . "</p>\n";

        $return .= "<p><input type=\"text\" name=\"disp_topics\" value=\""
            . $agoraUser['disp_topics'] . "\" size=\"6\" maxlength=\"3\" />" . JText::_('CB_AGORA_TOPICS_PER_PAGE') . "</p>\n";
        $return .= "<p><input type=\"text\" name=\"disp_posts\" value=\""
            . $agoraUser['disp_posts'] . "\" size=\"6\" maxlength=\"3\" />" . JText::_('CB_AGORA_POSTS_PER_PAGE') . "</p>\n";

        $return .= "<p>" . JText::_('CB_AGORA_MANAGE_REPUTATION') . "</p>";
        $return .= "<p><input type=\"radio\" name=\"reputation\" value=\"1\" "
            . ($agoraUser['reputation_enable']==1?"checked":"") . " />Yes\n";
        $return .= "<input type=\"radio\" name=\"reputation\" value=\"0\" "
            . ($agoraUser['reputation_enable']==0?"checked":"") . " />No</p>\n";

        return $return;
    }

    /**
    * Saves the user edit tab postdata into the tab's permanent storage
    * @param object tab reflecting the tab database entry
    * @param object mosUser reflecting the user being displayed
    * @param int 1 for front-end, 2 for back-end
    * @param array _POST data for saving edited tab content as generated with getEditTab
    * @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
    */
    function saveEditTab($tab, $user, $ui, $postdata)
    {
        global $_CB_database;

        $return = null;

        $query = "UPDATE #__agora_users SET ";

        $showSmiles = empty($postdata['show_smilies']) ? 0 : 1;
        $showSig = empty($postdata['show_sig']) ? 0 : 1;
        $showAvatars = empty($postdata['show_avatars']) ? 0 : 1;
        $showImg = empty($postdata['show_img']) ? 0 : 1;
        $showImgSig = empty($postdata['show_img_sig']) ? 0 : 1;
        $reversePosts = empty($postdata['reverse_posts']) ? 0 : 1;
        $dispTopics = (int)abs($postdata['disp_topics']);
        $dispPosts = (int)abs($postdata['disp_posts']);
        $reputation = $postdata['reputation']? 1 : 0;

        $query .= "`show_smilies`='$showSmiles', ";
        $query .= "`show_sig`='$showSig', ";
        $query .= "`show_avatars`='$showAvatars', ";
        $query .= "`show_img`='$showImg', ";
        $query .= "`show_img_sig`='$showImgSig', ";
        $query .= "`reverse_posts`='$reversePosts', ";
        $query .= "`disp_topics`='$dispTopics', ";
        $query .= "`disp_posts`='$dispPosts', ";
        $query .= "`reputation_enable`='$reputation' ";
        $query .= "WHERE `jos_id`='" . $user->id . "'";

        $_CB_database->setQuery( $query );
        if(!$_CB_database->query())
            JError::raiseWarning(0,$_CB_database->getErrorMsg());
        /*
        $this->_setErrorMSG($_CB_database->getErrorMsg());
        return false;   //FIXME: something strange, it does not wish to work
                        //therefore we use JError::raiseWarning function*/

        return true;
    }
}

class getAgoraPersonalTab extends cbTabHandler {
/**
     * Construnctor
     */
    function getPersonalDisplayTab()
    {
        $this->cbTabHandler();
    }

    /**
    * Generates the HTML to display the user profile personal tab
    * @param object tab reflecting the tab database entry
    * @param object mosUser reflecting the user being displayed
    * @param int 1 for front-end, 2 for back-end
    * @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
    */
    function getDisplayTab($tab,$user,$ui)
    {
        $return = null;
        $lang = JFactory::getLanguage();
        $lang->load('plg_cbagora');
        $agoraUser = cbAgoraGetUser($user->id);
        $dateFormat = cbAgoraDateFormat();
        switch($agoraUser['gender']) {
            case 1:
                $gender = JText::_('CB_AGORA_GENDER_MALE');
                break;
            case 2:
                $gender = JText::_('CB_AGORA_GENDER_FEMALE');
                break;
            default:
                $gender = JText::_('CB_AGORA_GENDER_HIDDEN');
        }


        $return .= "<p>" . JText::_('CB_AGORA_TITLE') . ":\t" . $agoraUser['title'] . "</p>\n";
        $return .= "<p>" . JText::_('CB_AGORA_LOCATION') . ":\t" . $agoraUser['location'] . "</p>\n";
        //TODO: add google maps to this place
        $return .= "<p>" . JText::_('CB_AGORA_WEBSITE') . ":\t<a href=\"" . $agoraUser['url'] .  "\">" . $agoraUser['url'] . "</a></p>";
        $return .= "<p>" . JText::_('CB_AGORA_GENDER') . ":\t" . $gender ."</p>";

        if ($agoraUser['hide_age']==1)
            $dateFormat = trim(eregi_replace('[ \./-]?y+[ \./-]?', '', $dateFormat));
        $return .= "<p>" . JText::_('CB_AGORA_BIRTHDAY') . ":\t". date($dateFormat, $agoraUser['birthday']) ."</p>";
        $return .= "<p>" . JText::_('CB_AGORA_BIRTHDAY_HIDE') . ":\t" . ($agoraUser['hide_age']==1?"Yes":"No") ."</p>";
        $return .= "<p>" . JText::_('CB_AGORA_INTERESTS') . ":\t" . $agoraUser['interests'] . "</p>";
        $return .= "<p>" . JText::_('CB_AGORA_SIGNATURE') . ":\t" . nl2br($agoraUser['signature']) . "</p>\n";

        return $return;
    }
    /**
    * Generates the HTML to display the user edit tab
    * @param object tab reflecting the tab database entry
    * @param object mosUser reflecting the user being displayed
    * @param int 1 for front-end, 2 for back-end
    * @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
    */
    function getEditTab($tab, $user, $ui)
    {
        global $_CB_framework;
        $return = null;
        $lang = JFactory::getLanguage();
        $lang->load('plg_cbagora');
        $agoraUser = cbAgoraGetUser($user->id);
        $day = (int)date("j",$agoraUser['birthday']);
        $month = (int)date("n",$agoraUser['birthday']);
        $year = (int)date("Y",$agoraUser['birthday']);
        $gmaps = cbAgoraGMaps();
        $lng = empty($agoraUser['longitude']) ? $gmaps['def_lng'] : $agoraUser['longitude'];
        $lat = empty($agoraUser['latitude']) ? $gmaps['def_lat'] : $agoraUser['latitude'];

        $return .= "<p><input type=\"text\" name=\"a_title\" value=\""
            . $agoraUser['title'] . "\" size=\"30\" maxlength=\"30\" />" . JText::_('CB_AGORA_TITLE') . "</p>\n";
        $return .= "<p><input type=\"text\" name=\"a_location\" value=\""
            . $agoraUser['location'] . "\" size=\"30\" maxlength=\"30\" />" . JText::_('CB_AGORA_LOCATION') . "</p>\n";

        $return .= "<script type=\"text/javascript\" src=\"http://maps.google.com/maps?file=api&amp;v=1&amp;key=".$gmaps['key']."\"></script>\n";
        $return .= "<script type=\"text/javascript\" src=\""
          . $_CB_framework->getCfg('live_site') . "/components/com_comprofiler/plugin/user/plug_agora/agora.js\"></script>\n";
        $return .= "<div id=\"map\" style=\"width: 500px; height: 400px; position:aboslute;\"></div>\n";
        $return .= "<script type=\"text/javascript\">\n
                    //<![CDATA[
                    window.onload=";
        $return .= "gMapProfile($lng, $lat, " . $gmaps['def_zoom'].",1);\n
                    //]]>
                    </script>
                    ";


        $return .= "<p><input type=\"text\" id=\"lat\" name=\"a_latitude\" value=\"".
            JString::trim($lat) ."\" size=\"50\" />" . JText::_('CB_AGORA_LATITUDE') . "</p>\n";
        $return .= "<p><input type=\"text\" id=\"lng\" name=\"a_longitude\" value=\"".
            JString::trim($lng) ."\" size=\"50\" />" . JText::_('CB_AGORA_LONGITUDE') . "</p>\n";
        $return .= "<p><input type=\"text\" name=\"a_url\" value=\""
            . $agoraUser['url'] . "\" size=\"50\" maxlength=\"80\" />" . JText::_('CB_AGORA_WEBSITE') . "</p>\n";

        $return .= "<p>Gender</p>\n";
        $return .= "<p><input type=\"radio\" name=\"a_gender\" value=\"1\" "
            . ($agoraUser['gender']==1?"checked":"") . " />" . JText::_('CB_AGORA_GENDER_MALE') . "\n";
        $return .= "<input type=\"radio\" name=\"a_gender\" value=\"2\" "
            . ($agoraUser['gender']==2?"checked":"") . " />" . JText::_('CB_AGORA_GENDER_FEMALE') . "</p>\n";
        $return .= "<p><input type=\"checkbox\" name=\"a_gender\" value=\"0\" "
            . ($agoraUser['gender']==0?"checked":"") . " />" . JText::_('CB_AGORA_GENDER_HIDDEN') . "</p>\n";

        //birthday part

        $return .= "<script type=\"text/javascript\" src=\"" . $_CB_framework->getCfg('live_site') . "/components/com_comprofiler/plugin/user/plug_agora/agora.js\"></script>";
        $return .= "<p>Birthday</p>\n";
        $return .= "<select id=\"birthday-day\" name=\"birthday-day\" style=\"width:50px; \" >\n";
        for( $i=1; $i<32; $i++)
            $return .= "<option value=\"" . $i . "\" " . ($day==$i ? "selected" : "") . ">" . $i . "</option>\n";
        $return .= "</select>\n";

        $return .= "<select id=\"birthday-month\" name=\"birthday-month\" onChange=\"rewrite_days();\" style=\"width:100px; \" >\n";
        $return .= "<option value=\"1\"" . ($month==1 ? "selected" : "") . ">January</option>";
        $return .= "<option value=\"2\"" . ($month==2 ? "selected" : "") . ">February</option>";
        $return .= "<option value=\"3\"" . ($month==3 ? "selected" : "") . ">March</option>";
        $return .= "<option value=\"4\"" . ($month==4 ? "selected" : "") . ">April</option>";
        $return .= "<option value=\"5\"" . ($month==5 ? "selected" : "") . ">May</option>";
        $return .= "<option value=\"6\"" . ($month==6 ? "selected" : "") . ">June</option>";
        $return .= "<option value=\"7\"" . ($month==7 ? "selected" : "") . ">July</option>";
        $return .= "<option value=\"8\"" . ($month==8 ? "selected" : "") . ">August</option>";
        $return .= "<option value=\"9\"" . ($month==9 ? "selected" : "") . ">September</option>";
        $return .= "<option value=\"10\"" . ($month==10 ? "selected" : "") . ">October</option>";
        $return .= "<option value=\"11\"" . ($month==11 ? "selected" : "") . ">November</option>";
        $return .= "<option value=\"12\"" . ($month==12 ? "selected" : "") . ">December</option>";
        $return .= "</select>\n";

        $return .= "<select id=\"birthday-year\" name=\"birthday-year\" onChange=\"rewrite_days();\" style=\"width:80px; \" >\n";
        for( $i=1922; $i<2002; $i++)
            $return .= "<option value=\"" . $i . "\" " . ((int)$year==$i ? "selected" : "") . ">" . $i . "</option>\n";
        $return .= "</select>\n";

        $return .= "<p><input type=\"checkbox\" name=\"a_hide_age\" "
            . ($agoraUser['hide_age']==1?"checked":"") . " />" . JText::_('CB_AGORA_BIRTHDAY_HIDE') . "</p>\n";

        $return .= "<p><input type=\"text\" name=\"a_interests\" value=\""
            . $agoraUser['interests'] . "\" size=\"70\" maxlength=\"254\" />" . JText::_('CB_AGORA_INTERESTS') . "</p>\n";

        $return .= "<p>" . JText::_('CB_AGORA_SIGNATURE_INFO') . "</p>\n";
        $return .= "<p>" . JText::_('CB_AGORA_SIGNATURE_MAXLENGTH') . ": 400 / " . JText::_('CB_AGORA_SIGNATURE_MAXLINES') . ": 4</p>\n";
        $return .= "<textarea name=\"a_sig\" rows=\"4\" cols=\"65\">" . $agoraUser['signature'] . "</textarea>";

        return $return;
    }

    /**
    * Saves the user edit tab postdata into the tab's permanent storage
    * @param object tab reflecting the tab database entry
    * @param object mosUser reflecting the user being displayed
    * @param int 1 for front-end, 2 for back-end
    * @param array _POST data for saving edited tab content as generated with getEditTab
    * @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
    */
    function saveEditTab($tab, $user, $ui, $postdata)
    {
        global $_CB_database;

        $return = null;

        $title = cbAgoraFilter(JString::substr($postdata['a_title'],0,30));
        $location = cbAgoraFilter(JString::substr($postdata['a_location'],0,30));
        $latitude = cbAgoraFilter(JString::substr($postdata['a_latitude'],0,50));
        $longitude = cbAgoraFilter(JString::substr($postdata['a_longitude'],0,50));
        $url = cbAgoraFilter(JString::substr($postdata['a_url'],0,80));
        $gender = cbAgoraFilter($postdata['a_gender']);
        $day = $postdata['birthday-day'];
        $month = $postdata['birthday-month'];
        $year = $postdata['birthday-year'];
        $birthday = mktime(0,0,0,$month,$day,$year);

        $sig = cbAgoraFilter(JString::substr($postdata['a_sig'],0,400));

        $hideAge = empty($postdata['a_hide_age']) ? 0 : 1;
        $interests = cbAgoraFilter(JString::substr($postdata['a_interests'],0,254));

        $query = "UPDATE #__agora_users SET ";

        $query .= "`title`=$title, ";
        $query .= "`location`=$location, ";
        $query .= "`latitude`=$latitude, ";
        $query .= "`longitude`=$longitude, ";
        $query .= "`url`=$url, ";
        $query .= "`gender`=$gender, ";
        $query .= "`birthday`='$birthday', ";
        $query .= "`hide_age`=$hideAge, ";
        $query .= "`signature`=$sig, ";
        $query .= "`interests`=$interests ";

        $query .= "WHERE `jos_id`='" . $user->id . "'";
        $_CB_database->setQuery( $query );
        if(!$_CB_database->query())
            JError::raiseWarning(0,$_CB_database->getErrorMsg());
        /*
        $this->_setErrorMSG($_CB_database->getErrorMsg());
        return false;   //FIXME: something strange, it does not wish to work
                        //therefore we use JError::raiseWarning function*/

        return true;
    }
}
?>
